<?xml version="1.0"?> 

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:include href="../shared/sprite-map.xsl"/>

<xsl:variable name="fileindex" select="document('../fileindex.xml')/files"/>

<xsl:variable name="id" select="concat(/graphic/type,/graphic/id,'_')"/>

<xsl:template name="add-sprites">
	<xsl:param name="count" select="0"/>

	
	
	<xsl:if test="$count &lt;= 0">
	
		<div>
			<xsl:attribute name="class"><xsl:value-of select="$id"/><xsl:value-of select="$count*-1"/></xsl:attribute>
		</div>
		<xsl:call-template name="add-sprites">
			<xsl:with-param name="count" select="$count + 1"/>
		</xsl:call-template>

	</xsl:if>

</xsl:template>



<xsl:template match="/">


<html>
	<head>
		<link href="../shared/common.css" media="screen" rel="stylesheet" type="text/css"/>
		
		<xsl:if test="/graphic/type = 'bg'">
			<xsl:call-template name="level-sprites">
				<xsl:with-param name="id" select="/graphic/id"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:if test="/graphic/type = 'characters'">
			<xsl:call-template name="other-sprites">
				<xsl:with-param name="type" select="'characters'"/>
			</xsl:call-template>
		</xsl:if>
	</head>
	
	<body>
		<xsl:call-template name="add-sprites">
			<xsl:with-param name="count"><xsl:value-of select="/graphic/sprites*-1"/></xsl:with-param>
		</xsl:call-template>
	</body>
</html>

</xsl:template>

</xsl:stylesheet>