<?xml version="1.0"?> 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="menucode">
	<xsl:param name="menu" select="0"/>
	
<p class="row">
	b<xsl:value-of select="$menu/x"/>;
	b<xsl:value-of select="$menu/y"/>;
	b<xsl:value-of select="$menu/width"/>;
	b<xsl:value-of select="$menu/array_x"/>;
	b<xsl:value-of select="$menu/array_y"/>;
	<xsl:for-each select="$menu/item">
		_<xsl:value-of select="."/>/;
	</xsl:for-each>
</p>
	
</xsl:template>


<xsl:template match="/">


<html>
	<head>
		<link href="../shared/common.css" media="screen" rel="stylesheet" type="text/css"/>
	</head>
	

	<body>
		<table>
			<tr><th class="title" colspan="2">Gamedata</th></tr>
			<tr>
				<th>Property</th>
				<th>Value</th>
			</tr>
			<tr>
				<td>Gamename</td>
				<td><xsl:value-of select='/gamedata/gamename'/></td>
			</tr>
			<tr>
				<td>Max level</td>
				<td><xsl:value-of select='/gamedata/max_level'/></td>
			</tr>
		</table>
		
		
		<table>
			<tr><th class="title" colspan="2">Character types</th></tr>
			<tr>
				<th>ID</th>
				<th>Types</th>
			</tr>
			<xsl:for-each select="/gamedata/types/type">
				<tr>
					<td><xsl:number value="position()-1"/></td>
					<td><xsl:value-of select='node()'/></td>
				</tr>
			</xsl:for-each>
		</table>
		
		<div class="code">
			<p class="row">
				_<xsl:value-of select='/gamedata/gamename'/>/;
				I<xsl:value-of select='/gamedata/max_level'/>;
			</p>
			
			<xsl:call-template name="menucode">
				<xsl:with-param name="menu" select="/gamedata/menus/menu[@name='main']"/>
			</xsl:call-template>
			<xsl:call-template name="menucode">
				<xsl:with-param name="menu" select="/gamedata/menus/menu[@name='ingame']"/>
			</xsl:call-template>
			<xsl:call-template name="menucode">
				<xsl:with-param name="menu" select="/gamedata/menus/menu[@name='character_actions']"/>
			</xsl:call-template>
			<xsl:call-template name="menucode">
				<xsl:with-param name="menu" select="/gamedata/menus/menu[@name='battleaction']"/>
			</xsl:call-template>
			
		</div>
	</body>
</html>
	
	
</xsl:template>
</xsl:stylesheet>