<?xml version="1.0"?> 

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:strip-space elements="p"/>
<xsl:template match="/">

<xsl:variable name="types" select="document('Gamedata.xml')/gamedata/types"/>

<html>
	<head>
		<link href="../shared/common.css" media="screen" rel="stylesheet" type="text/css"/>
		<style>th:not(.title){padding-top:15px}</style>
	</head>
	
	<body>
		<table>
			<tr>
				<th class="title" colspan="2">Attacks</th>
			</tr>
				<xsl:for-each select="/attack_list/attack">
					<tr>
						<th>#<xsl:number value="position()-1"/>:</th>
						<th><xsl:value-of select='name'/></th>
					</tr>
					<tr>
						<td>Type: </td>
						<xsl:variable name="Current_Type" select="type"/>
						<td><xsl:value-of select='$types/type[$Current_Type+1]'/></td>
					</tr>
					<tr>
						<td>Power: </td>
						<td><xsl:value-of select='power'/></td>
					</tr>
					<tr>
						<td>Hitratio: </td>
						<td><xsl:value-of select='hitratio'/>%</td>
					</tr>
					<tr>
						<td>PP usage: </td>
						<td><xsl:value-of select='PP_usage'/></td>
					</tr>
				</xsl:for-each>
		</table>
		
		
		
		
		<div class="code">
			<p class="init">b<xsl:value-of select='count(/attack_list/attack)'/>;</p>
			
			<xsl:for-each select="/attack_list/attack">
				<p class="row">
					_<xsl:value-of select='name'/>/;
					I<xsl:value-of select='power'/>;
					b<xsl:value-of select='hitratio'/>;
					I<xsl:value-of select='PP_usage'/>;
				</p>
			</xsl:for-each>
		</div>


	</body>
</html>
	
	
</xsl:template>
</xsl:stylesheet>