<?xml version="1.0"?> 

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:include href="sprite-map.xsl"/>

<xsl:template match="/">

<xsl:variable name="attacks" select="document('attack list.xml')/attack_list"/>

<html>
	<head>
		<link href="../shared/common.css" media="screen" rel="stylesheet" type="text/css"/>
		<style type="text/css" media="all">
			img{height:40px; width:40px; display:block;}
		</style>
	</head>
	
	<body>
		
		<table>
			<tr><th class="title" colspan="3">Characters</th></tr>
				<xsl:for-each select="/character_list/character">
						<tr>
							<td>
								<xsl:value-of select='name'/>
								<img><xsl:attribute name="src">characters/<xsl:value-of select='position()-1'/>.png</xsl:attribute></img>
							</td>
							
							<td>
								<table>
									<tr>
										<td>HP: </td>
										<td><xsl:value-of select='max_stats/hp'/></td>
									</tr>
									<tr>
										<td>PP: </td>
										<td><xsl:value-of select='max_stats/pp'/></td>
									</tr>
									<tr>
										<td>Attack: </td>
										<td><xsl:value-of select='max_stats/attack'/></td>
									</tr>
									<tr>
										<td>Defence: </td>
										<td><xsl:value-of select='max_stats/defence'/></td>
									</tr>
									<tr>
										<td>Speed: </td>
										<td><xsl:value-of select='max_stats/speed'/></td>
									</tr>
									
								</table>

							</td>
							
							<td>
								<table>
									<tr><td colspan="2">Lvl-up attacks</td></tr>
									<tr>
										<th>lvl</th>
										<th>Attack</th>
									</tr>
									<xsl:for-each select="lvlup_attacks/attack">
										<tr>
											<xsl:variable name="Current_Position" select="id"/>
											<td><xsl:value-of select='lvl'/></td>
											<td><xsl:value-of select='$attacks/attack[$Current_Position+1]/name'/></td>
										</tr>
									</xsl:for-each>
								</table>
							</td>
						</tr>
				</xsl:for-each>
		</table>
		

		<div class="code">
			<p class="init">b<xsl:value-of select='count(/character_list/character)'/>;</p>
			<xsl:for-each select="/character_list/character">
				<p class="row">
				_<xsl:value-of select='name'/>/;
				I<xsl:value-of select='max_stats/hp'/>;
				I<xsl:value-of select='max_stats/pp'/>;
				I<xsl:value-of select='max_stats/attack'/>;
				I<xsl:value-of select='max_stats/defence'/>;
				I<xsl:value-of select='max_stats/speed'/>;
				</p>
				
				<p class="init">b<xsl:value-of select='count(lvlup_attacks/attack)'/>;</p>
				<p class="row">
					<xsl:for-each select="lvlup_attacks/attack">
						b<xsl:value-of select='lvl'/>;
						b<xsl:value-of select='id'/>;
					</xsl:for-each>
				</p>
			</xsl:for-each>
		</div>

	</body>
</html>
	
	
</xsl:template>
</xsl:stylesheet>