<?xml version="1.0"?> 

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--
template: "sprite-map"

Parameters:
graphic: The node that includes the graphic information

-->


<xsl:template name="sprite-repeat">
	<xsl:param name="count" select="0"/>
	<xsl:param name="graphic" select="unspecified"/>

	<xsl:variable name="id" select="concat('.',$graphic/type,$graphic/id,'_')"/>
	
	<xsl:if test="$count > 0">
	
		<xsl:value-of select='$id'/><xsl:value-of select='$count'/>{background-position: -<xsl:value-of select="$count * $graphic/size_x"/>px 0px;}
		<xsl:call-template name="sprite-repeat">
			<xsl:with-param name="count" select="$count - 1"/>
			<xsl:with-param name="graphic" select="$graphic"/>
		</xsl:call-template>

	</xsl:if>

</xsl:template>





<xsl:template name="sprite-map">
	<xsl:param name="graphic" select="0"/>
	
	<style type="text/css">
		<!-- Define standart information -->
		[class*="<xsl:value-of select="concat($graphic/type,$graphic/id,'_')"/>"]{
			height:<xsl:value-of select='$graphic/size_x'/>px; width:<xsl:value-of select='$graphic/size_x'/>px;
			background-image:url('../graphics/<xsl:value-of select='$graphic/filename'/>');

		}
		<!-- Start defining coordinates to each sprite -->
		<xsl:call-template name="sprite-repeat">
			<xsl:with-param name="count" select="$graphic/sprites"/>
			<xsl:with-param name="graphic" select="$graphic"/>
		</xsl:call-template>
	</style>

	
</xsl:template>





<xsl:template name="level-sprites">
	<xsl:param name="id" select="0"/>

	<!-- Find the graphic file -->
	<xsl:variable name="fileindex" select="document('../fileindex.xml')/files"/>
	<xsl:variable name="filename" select="$fileindex/graphics/sprite[@id=$id]"/>
	<xsl:variable name="graphic" select="document(concat('../graphics/',$filename))/graphic"/>
	
	<xsl:call-template name="sprite-map">
		<xsl:with-param name="graphic" select="$graphic"/>
	</xsl:call-template>
</xsl:template>


<xsl:template name="other-sprites">
	<xsl:param name="type" select="0"/>


	<xsl:variable name="fileindex" select="document('../fileindex.xml')/files"/>
	
	<!-- Find the correct file -->
	<xsl:if test="$type = 'characters'">
		<xsl:variable name="filename" select="$fileindex/graphics/characters"/>
	
	<xsl:variable name="graphic" select="document(concat('../graphics/',$filename))/graphic"/>
	
	<xsl:call-template name="sprite-map">
		<xsl:with-param name="graphic" select="$graphic"/>
	</xsl:call-template>		
	</xsl:if>

</xsl:template>





</xsl:stylesheet>