#include <iostream>
#include <fstream>
#include <string>
#include <math.h> //pow() is used in float conversions

using namespace std;




class ErrorHandling{
	protected:
		int ErrorCode;
	
	public:
		virtual string GetError();
};















char * memblock; //For file operation
int filesize;



bool Load_File(string filename){
	ifstream file (&filename[0], ios::in|ios::binary|ios::ate);
									//Opening the file and start at the last byte
	bool success = false;
	filesize = 0;


	if(file.is_open()){
		success = true;

		ifstream::pos_type size;	//Make size variable
		size = file.tellg();		//Assign filesize to the variable
		memblock = new char [size];	//Make a char array as big as the file
		file.seekg (0, ios::beg);	//Go back to the beginning
		file.read (memblock, size);	//Read the whole file
		file.close();				//Close the file again
		
		filesize = size;
	}
	else
		cout << "Unable to open file!\n";


	return success;
}




//Convert a number stored as string to int
int Get_Number(char * memblock, int &pos){
	int result = 0;
	bool negative = false;
	pos++;//TODO: move this out of this...
	
	if(memblock[pos] == '-'){
		negative = true;
		pos++;
	}
	
	for( ; memblock[pos] != ';'; pos++){
		int ASCIInum = memblock[pos]-'0'; //Convert from ASCII to actual number
		
		if((ASCIInum >= 0) && (ASCIInum < 10)) //Was this even a number? Ignore and show error if not
			result = result * 10 + ASCIInum;
		else
			cout << "ERROR: Expected number, got \"" << memblock[pos] <<"\" instead!\n";
	}
	
	if(negative)
		result *= -1;
	
	return result;
}


//Convert a number stored as string to float
double Get_Float(char * memblock, int &pos){
	double result = 0;
	bool negative = false;
	bool decimal = false;
	
	int float_integer = 0;
	int float_decimals = 0;
	
	
	pos++;//TODO: move this out of this...
	
	if(memblock[pos] == '-'){
		negative = true;
		pos++;
	}
	
	int decimals_amount = 0;
	for( ; memblock[pos] != ';'; pos++){
		//is decimal point reached?
		if(memblock[pos] == '.'){
			decimal = true;
			continue;
		}
		
		int ASCIInum = memblock[pos]-'0'; //Convert from ASCII to actual number
		
		if((ASCIInum >= 0) && (ASCIInum < 10)) //Was this even a number? Ignore and show error if not
			if(decimal){
				float_decimals = float_decimals * 10 + ASCIInum;
				decimals_amount++;
			}
			else
				float_integer = float_integer * 10 + ASCIInum;

		else
			cout << "ERROR: Expected number, got \"" << memblock[pos] <<"\" instead!\n";
	}

	
	result = float_integer;

		
	//Convert to float
	result = float_integer + float_decimals / pow(10, decimals_amount);
	cout << decimals_amount << "\n";
	
	if(negative)//add sign
		result *= -1;
	
	return result;
}


string Get_String(char * memblock, int &pos){
	string text = "";
	
	for( ; !((memblock[pos-1] != '/') && (memblock[pos] == '/') && (memblock[pos+1] == ';')); pos++){
		string temp = " ";
		temp[0] = memblock[pos];
		
		//If "//;" is encountered, write ';' and ignore the other characters
		if((memblock[pos] == '/') && (memblock[pos+1] == '/') && (memblock[pos+2] == ';')){
			temp = ";";
			pos += 2;
		}
		
		text += temp;
	}
	
	return text;
}



void Number2binary(int value, char * bytes, int byte_amount, bool sign){
	
	//If signed, then check range and convert
	if(sign){
		if((value > -1*pow(2,8*byte_amount-1)) && (value < pow(2,8*byte_amount-1)-1)){
			value += (int)pow(2,8*byte_amount);
			if(value >= pow(2,8*byte_amount))
				value -= (int)pow(2,8*byte_amount);
		}
		else{
			cout << "ERROR: " << value << " cannot be saved as " << 8*byte_amount << "bit signed\n";
			value = 0;
		}
		
	}
	else //if not signed, just check range
		if(!(value < pow(2,8*byte_amount))){
			cout << "ERROR: " << value << " cannot be saved as " << 8*byte_amount << "bit unsigned\n";
			value = 0;
		}
	
	//Convert to bytes
	for(int byte = 0; byte < byte_amount; byte++)
		bytes[byte] = (value % (int)pow(256, byte+1)) / (int)pow(256, byte);
}


int main (){
	//Start interface
	cout << "NXT Convert\n";
	cout << "By Spiller\n";
	cout << "\n";

	
	bool program_running = true;
	while(program_running){
		string option;
		string filename;
		string memtemp;

		cout << "\nRead from [I]nput or [F]ile ([Q]uit for exit)?: ";
		cin >> option;

		switch(toupper(option[0])){ //option[0] is to prevent some que like thing... wierd bug...
			case 'F'://Read from file
					cout << "Enter filename: ";
					cin >> filename;
					Load_File(filename);
				break;
			case 'I'://Write input
					cout << "Write contents here:\n";
					cin >> memtemp;
					//TODO: convert memtemp to memblock
				break;
			case 'Q': program_running = false; break;
			default: cout << "Illegal choise! Legal choises are 'I', 'F', and 'Q'.\n";
		}//TODO: place this in a loop
		
		
		//quickfix
		if(!program_running)
			break;
		
		
		//TODO: only do this if memblock is prepared properly!
		//Begin to write
		ofstream binfile ("file.dat", ios::out|ios::binary|ios::trunc);
		
		for(int pos = 0; pos < filesize; pos++){
			char temptext[40];
			char WriteBytes[4];
			
			switch(memblock[pos]){
				case '_':{ //String, length in first byte
						pos++;
						string text = Get_String(memblock, pos);
						cout << text << " " << text.size() << "\n";
						if(text.size() < 256){
							WriteBytes[0] = text.size();
							binfile.write(WriteBytes, 1);
							binfile.write(&text[0], text.size());
						}
						else
							cout << "Error: string too long, max size is " << 256 << "\n";
					}
					break;
				
				case 'b': //write unsigned byte
						Number2binary(Get_Number(memblock, pos), WriteBytes, 1, false);
						binfile.write(WriteBytes,1);
					break;
				
				case 'B'://write signed byte
						Number2binary(Get_Number(memblock, pos), WriteBytes, 1, true);
						binfile.write(WriteBytes,1);
					break;
				
				case 'i': //write unsigned int
						Number2binary(Get_Number(memblock, pos), WriteBytes, 2, false);
						binfile.write(WriteBytes,2);
					break;

				case 'I': //Write signed int
						Number2binary(Get_Number(memblock, pos), WriteBytes, 2, true);
						binfile.write(WriteBytes,2);
					break;
					
				case 'l'://write unsigned long
						Number2binary(Get_Number(memblock, pos), WriteBytes, 4, true);
						binfile.write(WriteBytes,4);
					break;
				
				case 'L'://write signed long
						Number2binary(Get_Number(memblock, pos), WriteBytes, 4, true);
						binfile.write(WriteBytes,4);
					break;
				

				
				case 'f'://TODO: add support for NaN and infinity?
				case 'F':{
						double fvalue = Get_Float(memblock, pos);
						int sign_bin[1], mant_bin[24], exp_bin[8], float_bin[32];
						bool positive;
						int exp = 0;
						double mantisa;
						
						//Find sign
						if(fvalue >= 0)
							positive = true;
						else{
							positive = false;
							fvalue *= -1;
						}
						//Find exponent
						if(fvalue >= 1) //Find positive exponent
							while(fvalue / pow(2,exp) >= 2)
								exp++;
						else //Find negative exp
							while(fvalue / pow(2,exp) < 1)
								exp--;
						
						//Find mantisa
						mantisa = fvalue / pow(2,exp);
						
						
						//Convert sign to binary
						if(positive)
							sign_bin[0] = 0;
						else
							sign_bin[0] = 1;
						
						//Convert mantisa to binary
						for(int bit = 0; bit < 24; bit++){
							if(mantisa - 1/pow(2,bit) >= 0){
								mantisa -= 1/pow(2,bit);
								mant_bin[bit] = 1;
							}
							else
								mant_bin[bit] = 0;
						}
						
						//Convert exponent to binary
						exp += 127;
						for(int bit = 0; bit < 8; bit++){
							if(exp >= (int)pow(2,7-bit)){
								exp -= (int)pow(2,7-bit);
								exp_bin[bit] = 1;
							}
							else
								exp_bin[bit] = 0;
						}
						//TODO: correct last bit if wrong?
						
						//Combine binary sign, exponent, and mantise
						float_bin[0] = sign_bin[0];
						for(int bit = 1; bit < 9; bit++)
							float_bin[bit] = exp_bin[bit - 1];
						for(int bit = 9; bit < 32; bit++)
							float_bin[bit] = mant_bin[bit - 9 + 1];
						
						/* Show output
						for(int bit = 0; bit < 32; bit++)
							cout << float_bin[bit];
						cout << "\n";//*/
						
						//Convert to bytes
						for(int byte_no=0; byte_no < 4; byte_no++){
							WriteBytes[byte_no*-1+3] = 0;
							for(int bit = 7; bit >= 0; bit--){
								WriteBytes[byte_no*-1+3] += float_bin[byte_no*8 + bit] * (int)pow(2, bit*-1+7);
							}
						}
						
						//Finally, write the data
						binfile.write(WriteBytes,4);
						
						cout << "\n";
					}
					break;
				
				
				case '%':{
						int first_range = Get_Number(memblock, pos);
						int second_range = 8 - first_range;
						
						int value1 = Get_Number(memblock, pos);
						int value2 = Get_Number(memblock, pos);
						
						
						//Abort if the range is bad
						if( !((first_range > 0) && (first_range < 8)) ){
							cout << "Error: range is bad: " << first_range << "\n";
							break;
						}
						
						//Abort if the values are bad
						if( !((value1 >= 0) && (value2 >= 0)) ){
							cout << "Error: values are bad, must be positive: " << value1 << " & " << value2 << "\n";
							break;
						}
						
						
						//Merge numbers together
						int merged_number = value1 * (int)pow(2, second_range) + value2;
						
						cout << "Result of merging: " << merged_number << "\n";
						cout << "Result of merging: "
							<< merged_number/128%2
							<< merged_number/64%2
							<< merged_number/32%2
							<< merged_number/16%2
							<< merged_number/8%2
							<< merged_number/4%2
							<< merged_number/2%2
							<< merged_number/1%2
							<< "\n";
							
						Number2binary(merged_number, WriteBytes, 1, false);
						binfile.write(WriteBytes,1);
					}
					break;
			}
		}
		
		binfile.close();
		
	}

}
